Index: java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java
===================================================================
--- java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 97)
@@ -11,6 +11,6 @@
 import org.apache.log4j.Logger;
 
-import com.framsticks.core.AbstractInstanceListener;
-import com.framsticks.core.Instance;
+import com.framsticks.core.AbstractTreeListener;
+import com.framsticks.core.Tree;
 import com.framsticks.core.Path;
 import com.framsticks.dumping.PrintWriterSink;
@@ -19,8 +19,9 @@
 import com.framsticks.remote.RecursiveFetcher;
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.Logging;
 import com.framsticks.util.PeriodicTask;
-import com.framsticks.util.StateFunctor;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
 import com.framsticks.util.io.Encoding;
 
@@ -28,5 +29,5 @@
  * @author Piotr Sniegowski
  */
-public class Diagnostics extends JoinableCollection<Instance> {
+public class Diagnostics extends JoinableCollection<Tree> {
 	private static final Logger log = Logger.getLogger(Diagnostics.class);
 
@@ -41,10 +42,11 @@
 
 
+
 	@Override
 	@AutoAppendAnnotation
-	public void add(final Instance instance) {
-		super.add(instance);
+	public void add(final Tree tree) {
+		super.add(tree);
 
-		instance.addListener(new AbstractInstanceListener() {
+		tree.addListener(new AbstractTreeListener() {
 			@Override
 			public void onRun(Exception e) {
@@ -54,39 +56,36 @@
 
 				if (dumpsInterval != null) {
-					new PeriodicTask<Instance>(instance, dumpsInterval * 1000) {
+					new PeriodicTask<Tree>(ThrowExceptionHandler.getInstance(), tree, dumpsInterval * 1000) {
+						protected final ExceptionResultHandler repeater = new ExceptionResultHandler() {
+
+							@Override
+							public void handle(FramsticksException exception) {
+								log.error("caught error during diagnostics fetching (repeating): " + exception);
+								again();
+							}
+
+						};
 						@Override
-						public void run() {
+						protected void runAt() {
 
 							log.info("starting periodic dump");
-							new RecursiveFetcher(instance, Path.to(instance, "/"), new StateFunctor() {
-								@Override
-								public void handle(FramsticksException e) {
-									Logging.log(log, "recursively fetch", instance, e);
-									again();
-								}
+							new RecursiveFetcher(tree, Path.to(tree, "/"), new FutureHandler<Void>(repeater) {
 
 								@Override
-								public void call() {
-									log.info("instance resolved, saving");
+								protected void result(Void result) {
+									log.info("tree resolved, saving");
 									try {
-										final String fileName = dumpsPath + "/" + instance + "_" + new SimpleDateFormat(dumpsFormat).format(new Date()) + ".param";
+										final String fileName = dumpsPath + "/" + tree + "_" + new SimpleDateFormat(dumpsFormat).format(new Date()) + ".param";
 										File file = new File(fileName);
-										new SaveStream(new PrintWriterSink(new PrintWriter(new OutputStreamWriter(new FileOutputStream(file), Encoding.getFramsticksCharset()))), instance, Path.to(instance, "/"), new StateFunctor() {
-											@Override
-											public void handle(FramsticksException e) {
-												Logging.log(log, "periodic dump in " + fileName + " of", instance, e);
-												again();
-											}
+										new SaveStream(new PrintWriterSink(new PrintWriter(new OutputStreamWriter(new FileOutputStream(file), Encoding.getFramsticksCharset()))), tree, Path.to(tree, "/"), new FutureHandler<Void>(repeater) {
 
 											@Override
-											public void call() {
+											protected void result(Void result) {
 												again();
 											}
 										});
-									} catch (IOException ex) {
-										log.info("failed to initiate dump: " + ex);
-										again();
+									} catch (IOException e) {
+										throw new FramsticksException().msg("failed to initiate dump").cause(e);
 									}
-
 								}
 							});
Index: java/main/src/main/java/com/framsticks/dumping/LoadStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 97)
@@ -2,8 +2,8 @@
 
 import com.framsticks.communication.File;
-import com.framsticks.core.InstanceUtils;
+import com.framsticks.core.TreeOperations;
 import com.framsticks.core.Path;
 import com.framsticks.params.ListSource;
-import com.framsticks.core.Instance;
+import com.framsticks.core.Tree;
 import com.framsticks.util.*;
 import com.framsticks.util.dispatching.Future;
@@ -24,5 +24,5 @@
 	private final static Logger log = Logger.getLogger(LoadStream.class.getName());
 
-	protected final Instance instance;
+	protected final Tree tree;
 	protected final Path mountPath;
 	protected final BufferedReader stream;
@@ -31,6 +31,6 @@
 
 
-	public LoadStream(Path mountPath, BufferedReader stream, Instance instance, Future<Path> future) {
-		this.instance = instance;
+	public LoadStream(Path mountPath, BufferedReader stream, Tree tree, Future<Path> future) {
+		this.tree = tree;
 		this.mountPath = mountPath;
 		this.stream = stream;
@@ -59,9 +59,9 @@
 					if (line.equals("ok")) {
 						if (query.first.equals("get")) {
-							Path path = InstanceUtils.createIfNeeded(instance, query.second);
-							InstanceUtils.processFetchedValues(path, files);
+							Path path = TreeOperations.createIfNeeded(tree, query.second);
+							TreeOperations.processFetchedValues(path, files);
 						} else if (query.first.equals("info")) {
 							assert files.size() == 1;
-							InstanceUtils.processFetchedInfo(instance, files.get(0));
+							TreeOperations.processFetchedInfo(tree, files.get(0));
 						} else {
 							assert false;
@@ -87,5 +87,5 @@
 		}
 		log.info("loaded in: " + stopwatch);
-		future.pass(Path.to(instance, mountPath.getTextual()));
+		future.pass(Path.to(tree, mountPath.getTextual()));
 	}
 
Index: java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 97)
@@ -1,5 +1,5 @@
 package com.framsticks.dumping;
 
-import static com.framsticks.core.InstanceUtils.*;
+import static com.framsticks.core.TreeOperations.*;
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
@@ -10,7 +10,10 @@
 import com.framsticks.params.SinkInterface;
 import com.framsticks.parsers.Savers;
-import com.framsticks.core.Instance;
+import com.framsticks.core.Tree;
 import com.framsticks.util.*;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
 import org.apache.log4j.Logger;
 import com.framsticks.util.dispatching.RunAt;
@@ -28,6 +31,6 @@
 
 	protected final SinkInterface sink;
-	protected final Instance instance;
-	protected final StateFunctor stateFunctor;
+	protected final Tree tree;
+	protected final Future<Void> future;
 	protected final Stopwatch stopwatch = new Stopwatch();
 	protected final Set<FramsClass> storedInfo = new HashSet<FramsClass>();
@@ -35,9 +38,9 @@
 	private int dispatched = 0;
 
-	public SaveStream(SinkInterface sink, Instance instance, Path root, StateFunctor stateFunctor) {
+	public SaveStream(SinkInterface sink, Tree tree, Path root, Future<Void> future) {
 		assert Dispatching.isThreadSafe();
 		this.sink = sink;
-		this.instance = instance;
-		this.stateFunctor = stateFunctor;
+		this.tree = tree;
+		this.future = future;
 		dispatchWrite(root);
 	}
@@ -45,7 +48,8 @@
 	protected void dispatchWrite(final Path path) {
 		++dispatched;
-		instance.dispatch(new RunAt<Instance>() {
+		//TODO TEH
+		tree.dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				write(path);
 			}
@@ -54,11 +58,11 @@
 
 	protected void finished() {
-		assert instance.isActive();
+		assert tree.isActive();
 		log.info("stored in " + stopwatch);
-		stateFunctor.call();
+		future.pass(null);
 	}
 
 	public void write(final Path path) {
-		assert instance.isActive();
+		assert tree.isActive();
 		if (!path.isResolved()) {
 			log.debug("path " + path + " is not resolved - skipping");
Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 97)
@@ -2,11 +2,17 @@
 
 import com.framsticks.core.*;
+import com.framsticks.gui.console.Console;
+import com.framsticks.gui.console.TrackConsole;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.remote.RemoteTree;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
@@ -19,5 +25,9 @@
 
 import java.awt.Dimension;
+import java.awt.Toolkit;
+import java.awt.datatransfer.StringSelection;
+import java.awt.event.ActionEvent;
 import java.util.ArrayList;
+import java.util.LinkedList;
 import java.util.List;
 import com.framsticks.util.dispatching.RunAt;
@@ -27,13 +37,16 @@
  */
 @FramsClassAnnotation
-public class Browser extends AbstractJoinable implements Dispatcher<Browser>, JoinableParent {
-
-	private static final Logger log = Logger.getLogger(Browser.class.getName());
-
-	protected JoinableCollection<Frame> frames = new JoinableCollection<Frame>().setObservableName("frames");
-	protected JoinableCollection<Instance> instances = new JoinableCollection<Instance>().setObservableName("instances");
-
-	protected MainFrame mainFrame;
-	public List<PanelProvider> panelProviders = new ArrayList<PanelProvider>();
+public class Browser extends AbstractJoinable implements Dispatcher<Browser>, JoinableParent, ExceptionResultHandler {
+
+	private static final Logger log = Logger.getLogger(Browser.class);
+
+	protected final JoinableCollection<Frame> frames = new JoinableCollection<Frame>().setObservableName("frames");
+	protected final JoinableCollection<Tree> trees = new JoinableCollection<Tree>().setObservableName("trees");
+	protected final JoinableCollection<Console> consoles = new JoinableCollection<Console>().setObservableName("consoles");
+
+	protected final List<PopupMenuEntryProvider> popupMenuEntryProviders = new LinkedList<>();
+
+	protected final MainFrame mainFrame;
+	protected final List<PanelProvider> panelProviders = new ArrayList<PanelProvider>();
 	protected Dimension defaultFrameDimension;
 
@@ -51,4 +64,44 @@
 		mainFrame = new MainFrame(Browser.this);
 		addFrame(mainFrame);
+
+		addPopupMenuEntryProvider(new PopupMenuEntryProvider() {
+			@Override
+			public void provide(JPopupMenu menu, Path path) {
+				menu.add(new JMenuItem(path.getFullTextual()));
+				menu.addSeparator();
+			}
+		});
+
+		addPopupMenuEntryProvider(new PopupMenuEntryProvider() {
+			@SuppressWarnings("serial")
+			@Override
+			public void provide(JPopupMenu menu, final Path path) {
+				menu.add(new AbstractAction("Copy path to clipboard") {
+					@Override
+					public void actionPerformed(ActionEvent e) {
+						Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(path.getFullTextual()), null);
+					}
+				});
+			}
+		});
+
+		addPopupMenuEntryProvider(new PopupMenuEntryProvider() {
+			@SuppressWarnings("serial")
+			@Override
+			public void provide(JPopupMenu menu, final Path path) {
+				if (!(path.getTree() instanceof RemoteTree)) {
+					return;
+				}
+				final RemoteTree remoteTree = (RemoteTree) path.getTree();
+				menu.add(new AbstractAction("Open tracking console") {
+					@Override
+					public void actionPerformed(ActionEvent e) {
+						consoles.add(new TrackConsole().setConnection(remoteTree.getConnection()));
+					}
+				});
+			}
+		});
+		// addNodeActionToTreePopupMenu("", new NodeAction() )
+
 	}
 
@@ -60,21 +113,26 @@
 
 	@AutoAppendAnnotation
-	public void addInstance(Instance instance) {
-		log.info("adding instance: " + instance);
-		instances.add(instance);
+	public void addPopupMenuEntryProvider(PopupMenuEntryProvider popupMenuEntryProvider) {
+		popupMenuEntryProviders.add(popupMenuEntryProvider);
+	}
+
+	@AutoAppendAnnotation
+	public void addTree(Tree tree) {
+		log.info("adding tree: " + tree);
+		trees.add(tree);
 	}
 
 	public void autoResolvePath(final String path, final Future<Path> future) {
-		final Instance i = instances.get("localhost");
-		i.dispatch(new RunAt<Instance>() {
-			@Override
-			public void run() {
-				InstanceUtils.resolveAndFetch(i, path, new Future<Path>(future) {
+		final Tree i = trees.get("localhost");
+		i.dispatch(new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				TreeOperations.resolveAndGet(i, path, new FutureHandler<Path>(future) {
 					@Override
 					protected void result(final Path p) {
 						future.pass(p);
-						mainFrame.dispatch(new RunAt<Frame>() {
+						mainFrame.dispatch(new RunAt<Frame>(future) {
 							@Override
-							public void run() {
+							protected void runAt() {
 								mainFrame.goTo(p);
 							}
@@ -93,58 +151,7 @@
 	}
 
-	protected void initializeGUI() {
-		assert isActive();
-		log.debug("executing first task");
-
-		try {
-			boolean found = false;
-			// for (LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
-			//	log.info("look and feel available: " + info.getName());
-			//	if ("Nimbus".equals(info.getName())) {
-			//		UIManager.setLookAndFeel(info.getClassName());
-			//		found = true;
-			//		break;
-			//	}
-			// }
-			if (!found) {
-				UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
-			}
-		} catch (Exception ex) {
-			log.warn("failed loading Look&Feel: ", ex);
-		}
-
-		javax.swing.JFrame.setDefaultLookAndFeelDecorated(true);
-
-
-		for (Frame f : frames) {
-			f.configure();
-		}
-
-		for (final Instance i : instances) {
-			i.dispatch(new RunAt<Instance>() {
-				@Override
-				public void run() {
-					final Path p = Path.to(i, "/");
-					dispatch(new RunAt<Browser>() {
-						@Override
-						public void run() {
-							mainFrame.addRootPath(p);
-						}
-					});
-				}
-			});
-		}
-
-		for (Frame f : frames) {
-			f.getSwing().setVisible(true);
-		}
-
-		// autoResolvePath("/simulator/genepools/groups/0", null);
-		// autoResolvePath("/", null);
-	}
-
 	public void createTreeNodeForChild(final Path path) {
 		assert !isActive();
-		//assert instance.isActive();
+		//assert tree.isActive();
 
 		/*
@@ -174,19 +181,34 @@
 	protected void joinableStart() {
 		Dispatching.use(frames, this);
-		Dispatching.use(instances, this);
-
-		dispatch(new RunAt<Browser>() {
-			@Override
-			public void run() {
-				initializeGUI();
-			}
-		});
-	}
-
-	/**
-	 * @return the instances
-	 */
-	public JoinableCollection<Instance> getInstances() {
-		return instances;
+		Dispatching.use(trees, this);
+		Dispatching.use(consoles, this);
+
+		dispatch(new RunAt<Browser>(this) {
+			@Override
+			protected void runAt() {
+
+				for (final Tree i : trees) {
+					i.dispatch(new RunAt<Tree>(this) {
+						@Override
+						protected void runAt() {
+							final Path p = Path.to(i, "/");
+							dispatch(new RunAt<Browser>(this) {
+								@Override
+								protected void runAt() {
+									mainFrame.addRootPath(p);
+								}
+							});
+						}
+					});
+				}
+			}
+		});
+	}
+
+	/**
+	 * @return the tree
+	 */
+	public JoinableCollection<Tree> getTrees() {
+		return trees;
 	}
 
@@ -227,5 +249,6 @@
 	protected void joinableJoin() throws InterruptedException {
 		Dispatching.join(frames);
-		Dispatching.join(instances);
+		Dispatching.join(trees);
+		Dispatching.join(consoles);
 		// super.join();
 	}
@@ -233,6 +256,7 @@
 	@Override
 	protected void joinableInterrupt() {
+		Dispatching.drop(consoles, this);
 		Dispatching.drop(frames, this);
-		Dispatching.drop(instances, this);
+		Dispatching.drop(trees, this);
 	}
 
@@ -255,8 +279,12 @@
 	}
 
+	@Override
+	public void handle(FramsticksException exception) {
+		mainFrame.handle(exception);
+	}
 
 	// @Override
 	// public boolean isDone() {
-	//	return frames.isDone() && instances.isDone();
+	//	return frames.isDone() && trees.isDone();
 	// }
 }
Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 97)
@@ -1,29 +1,57 @@
 package com.framsticks.gui;
 
-import com.framsticks.core.Instance;
-import com.framsticks.core.Path;
-import com.framsticks.gui.view.*;
-import com.framsticks.gui.view.TreeCellRenderer;
-import com.framsticks.util.dispatching.Dispatcher;
-import com.framsticks.util.dispatching.JoinableCollection;
-import com.framsticks.util.lang.ScopeEnd;
-import com.framsticks.util.swing.KeyboardModifier;
-import com.framsticks.util.swing.MenuConstructor;
-
-import org.apache.log4j.Logger;
-
-import javax.swing.*;
+import java.awt.BorderLayout;
+import java.awt.CardLayout;
+import java.awt.Color;
+import java.awt.Container;
+import java.awt.Dimension;
+import java.awt.Toolkit;
+import java.awt.event.ActionEvent;
+import java.awt.event.KeyEvent;
+import java.awt.event.MouseAdapter;
+import java.awt.event.MouseEvent;
+import java.util.HashMap;
+import java.util.Map;
+
+import javax.swing.AbstractAction;
+import javax.swing.BorderFactory;
+import javax.swing.JComponent;
+import javax.swing.JMenu;
+import javax.swing.JMenuBar;
+import javax.swing.JMenuItem;
+import javax.swing.JPanel;
+import javax.swing.JPopupMenu;
+import javax.swing.JScrollPane;
+import javax.swing.JSplitPane;
+import javax.swing.JTree;
+import javax.swing.KeyStroke;
+import javax.swing.ToolTipManager;
+import javax.swing.UIManager;
 import javax.swing.event.TreeModelEvent;
 import javax.swing.event.TreeModelListener;
 import javax.swing.event.TreeSelectionEvent;
 import javax.swing.event.TreeSelectionListener;
-import javax.swing.tree.*;
-
-import java.awt.*;
-import java.awt.datatransfer.StringSelection;
-import java.awt.event.*;
-import java.util.HashMap;
-import java.util.Map;
+import javax.swing.tree.DefaultMutableTreeNode;
+import javax.swing.tree.DefaultTreeModel;
+import javax.swing.tree.DefaultTreeSelectionModel;
+import javax.swing.tree.TreePath;
+import javax.swing.tree.TreeSelectionModel;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.Path;
+import com.framsticks.core.Tree;
+import com.framsticks.gui.view.TreeCellRenderer;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
 import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.lang.ScopeEnd;
+import com.framsticks.util.swing.KeyboardModifier;
+import com.framsticks.util.swing.MenuConstructor;
 
 /**
@@ -31,5 +59,5 @@
  */
 @SuppressWarnings("serial")
-public class Frame extends JoinableCollection<Instance> implements Dispatcher<Frame> {
+public class Frame extends FrameJoinable implements JoinableParent {
 
 	private static final Logger log = Logger.getLogger(Frame.class.getName());
@@ -42,11 +70,8 @@
 	protected JPanel cardPanel;
 
-	protected final String title;
-	protected JFrame swing;
 	protected JScrollPane treeScrollPane;
-	protected JTree tree;
+	protected JTree jtree;
 	protected DefaultTreeModel treeModel;
 	protected javax.swing.tree.MutableTreeNode rootNode;
-	//final Instance instance;
 	protected JPanel treePanel;
 	protected JPopupMenu treePopupMenu;
@@ -54,5 +79,4 @@
 
 	TreeNode currentlyPoppedTreeNode;
-	protected JLabel statusBar;
 	protected JPanel mainPanel;
 	protected JPanel leftPanel;
@@ -67,21 +91,13 @@
 	protected JMenu helpMenu;
 
-	protected final Map<Instance, InstanceAtFrame> instancesAtFrames = new HashMap<Instance, InstanceAtFrame>();
-
-	public Frame(String title, Browser browser) {
-		this.title = title;
+	protected final Map<Tree, TreeAtFrame> treeAtFrames = new HashMap<Tree, TreeAtFrame>();
+	protected JoinableCollection<Tree> trees = new JoinableCollection<Tree>();
+
+	public Frame(Browser browser) {
 		this.browser = browser;
 	}
 
-	public void configure() {
-		swing = new JFrame(title);
-		swing.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
-		swing.addWindowListener(new WindowAdapter() {
-			@Override
-			public void windowClosing(WindowEvent e) {
-				log.info("received closing");
-				interrupt();
-			}
-		});
+	protected void initializeGui() {
+		super.initializeGui();
 		/** this is done to remove the current value label from above the slider,
 		 * because it cannot put to work properly with floating-point value sliders,
@@ -90,33 +106,8 @@
 		log.debug("creating " + this);
 
-		statusBar = new JLabel("not connected");
-
-		Container contentPane = swing.getContentPane();
-		contentPane.setLayout(new BorderLayout());
-
+
+		Container contentPane = getSwing().getContentPane();
 		treePopupMenu = new JPopupMenu("title");
 		treePopupMenu.setName("popup");
-		treePopupMenuHeader = new JMenuItem();
-		treePopupMenuHeader.setForeground(Color.BLUE);
-		treePopupMenu.add(treePopupMenuHeader);
-		treePopupMenu.addSeparator();
-		//TODO: add to favourites
-		//TODO: remove from favourites
-		//TODO: open in new window as root
-		//TODO: refresh
-		//TODO: open in console
-
-		treePopupMenu.add(new JMenuItem("Refresh"));
-		treePopupMenu.add(new JMenuItem("Open in new frame as root"));
-		addNodeActionToTreePopupMenu("Copy path to clipboard", new NodeAction() {
-			@Override
-			public void actionPerformed(TreeNode treeNode) {
-				Path path = treeNode.getInstancePath();
-				StringSelection selection = new StringSelection(path.toString());
-				swing.getToolkit().getSystemClipboard().setContents(selection, selection);
-			}
-		});
-		//this.add(createMenuItem("Add to favourites", null));
-		//this.add(createMenuItem("Remove from favourites", null));
 
 		treePanel = new JPanel();
@@ -147,12 +138,12 @@
 		});
 
-		tree = new JTree(treeModel);
-		tree.setName("tree");
-		tree.setRootVisible(false);
-		tree.setExpandsSelectedPaths(true);
-		tree.setSelectionModel(new DefaultTreeSelectionModel());
-		ToolTipManager.sharedInstance().registerComponent(tree);
-
-		tree.addTreeSelectionListener(new TreeSelectionListener() {
+		jtree = new JTree(treeModel);
+		jtree.setName("tree");
+		jtree.setRootVisible(false);
+		jtree.setExpandsSelectedPaths(true);
+		jtree.setSelectionModel(new DefaultTreeSelectionModel());
+		ToolTipManager.sharedInstance().registerComponent(jtree);
+
+		jtree.addTreeSelectionListener(new TreeSelectionListener() {
 			@Override
 			public void valueChanged(TreeSelectionEvent e) {
@@ -161,12 +152,12 @@
 		});
 
-		tree.setExpandsSelectedPaths(true);
-		tree.setEditable(false);
-		tree.setDoubleBuffered(true);
-		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
-		tree.setShowsRootHandles(true);
-		tree.setRowHeight(26);
-		tree.setDoubleBuffered(true);
-		tree.addMouseListener(new MouseAdapter() {
+		jtree.setExpandsSelectedPaths(true);
+		jtree.setEditable(false);
+		jtree.setDoubleBuffered(true);
+		jtree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
+		jtree.setShowsRootHandles(true);
+		jtree.setRowHeight(26);
+		jtree.setDoubleBuffered(true);
+		jtree.addMouseListener(new MouseAdapter() {
 			@Override
 			public void mousePressed(MouseEvent e) {
@@ -182,9 +173,9 @@
 		});
 
-		new KeyboardModifier(tree, JComponent.WHEN_FOCUSED).join(KeyStroke.getKeyStroke('h'), KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 0)).join(KeyStroke.getKeyStroke('j'), KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0)).join(KeyStroke.getKeyStroke('k'), KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0)).join(KeyStroke.getKeyStroke('l'), KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0));
-
-		tree.setCellRenderer(new TreeCellRenderer());
-
-		treeScrollPane = new JScrollPane(tree);
+		new KeyboardModifier(jtree, JComponent.WHEN_FOCUSED).join(KeyStroke.getKeyStroke('h'), KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 0)).join(KeyStroke.getKeyStroke('j'), KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0)).join(KeyStroke.getKeyStroke('k'), KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0)).join(KeyStroke.getKeyStroke('l'), KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0));
+
+		jtree.setCellRenderer(new TreeCellRenderer());
+
+		treeScrollPane = new JScrollPane(jtree);
 		treeScrollPane.setBorder(BorderFactory.createEmptyBorder());
 
@@ -215,5 +206,4 @@
 		contentPane.add(menuBar, BorderLayout.NORTH);
 		contentPane.add(mainPanel, BorderLayout.CENTER);
-		contentPane.add(statusBar, BorderLayout.SOUTH);
 
 		leftPanel = new JPanel();
@@ -246,6 +236,6 @@
 		cardPanel.setLayout(cardPanelLayout);
 
-		swing.pack();
-		tree.requestFocusInWindow();
+		getSwing().pack();
+		jtree.requestFocusInWindow();
 
 		log.debug("frame configured: " + this);
@@ -266,45 +256,16 @@
 	public void addRootPath(Path path) {
 		assert isActive();
-		Instance instance = path.getInstance();
-		assert browser.getInstances().contains(instance);
-
-		InstanceAtFrame e = new InstanceAtFrame(instance, this);
-		instance.addListener(e);
-		instancesAtFrames.put(instance, e);
+		Tree tree = path.getTree();
+		assert browser.getTrees().contains(tree);
+
+		TreeAtFrame e = new TreeAtFrame(tree, this);
+		tree.addListener(e);
+		treeAtFrames.put(tree, e);
 		TreeNode node = new TreeNode(e, path);
 		e.rootTreeNode = node;
 		treeModel.insertNodeInto(node, rootNode, rootNode.getChildCount());
-		tree.expandPath(new TreePath(rootNode));
-	}
-
-	@Override
-	public boolean isActive() {
-		return SwingDispatcher.instance.isActive();
-	}
-
-	@Override
-	public void dispatch(RunAt<? extends Frame> runnable) {
-		SwingDispatcher.getInstance().dispatch(runnable);
-	}
-
-	public Action addActionToTreePopupMenu(Action action) {
-		assert isActive();
-		treePopupMenu.add(action);
-		return action;
-	}
-
-	public Action addNodeActionToTreePopupMenu(String title, final NodeAction nodeAction) {
-		assert isActive();
-		return addActionToTreePopupMenu(new AbstractAction(title) {
-			@Override
-			public void actionPerformed(ActionEvent e) {
-				TreeNode treeNode = getCurrentlyPoppedTreeNode();
-				if (treeNode == null) {
-					return;
-				}
-				nodeAction.actionPerformed(treeNode);
-			}
-		});
-	}
+		jtree.expandPath(new TreePath(rootNode));
+	}
+
 
 	public void showPanel(Panel panel) {
@@ -319,18 +280,18 @@
 			return;
 		}
-		currentlyPoppedTreeNode = findTreeNodeByTreePath(tree.getPathForLocation(e.getX(), e.getY()));
+		currentlyPoppedTreeNode = findTreeNodeByTreePath(jtree.getPathForLocation(e.getX(), e.getY()));
 		if (currentlyPoppedTreeNode == null) {
 			return;
 		}
+
+		Path path = currentlyPoppedTreeNode.getTreePath();
+		treePopupMenu.removeAll();
+
+		for (PopupMenuEntryProvider provider : browser.popupMenuEntryProviders) {
+			provider.provide(treePopupMenu, path);
+		}
+		// treePopupMenuHeader.setText(path.getTree().getName() + path.getTextual());
 		treePopupMenu.show(e.getComponent(), e.getX(), e.getY());
 		//currentlyPoppedPanel.getNode().getFramsClass().getName()
-		//treePopupMenuHeader.setText(currentlyPoppedTreeNode.getNode().getPath());
-	}
-
-	/**
-	 * @return the swing
-	 */
-	public JFrame getSwing() {
-		return swing;
 	}
 
@@ -344,10 +305,10 @@
 		cardPanel.removeAll();
 		cardPanel.updateUI();
-		tree.setEnabled(false);
+		jtree.setEnabled(false);
 	}
 
 	public ScopeEnd startChange(final DefaultMutableTreeNode node) {
 		assert isActive();
-		final TreePath selection = tree.getSelectionPath();
+		final TreePath selection = jtree.getSelectionPath();
 		return new ScopeEnd() {
 			@Override
@@ -355,5 +316,5 @@
 				assert isActive();
 				treeModel.nodeChanged(node);
-				tree.setSelectionPath(selection);
+				jtree.setSelectionPath(selection);
 			}
 		};
@@ -391,18 +352,28 @@
 	}
 
+	protected final ExceptionResultHandler dialogHandler = new ExceptionResultHandler() {
+
+		@Override
+		public void handle(FramsticksException exception) {
+			//TODO TEH
+			throw exception;
+
+		}
+	};
+
 	public void goTo(Path path) {
 		assert isActive();
-		final TreePath treePath = instancesAtFrames.get(path.getInstance()).getTreePath(path, false);
+		final TreePath treePath = treeAtFrames.get(path.getTree()).getTreePath(path, false);
 		log.info("go to path: " + path + "(" + treePath + ")");
 
-		new RunAt<Frame>(this) {
-			@Override
-			public void run() {
+		this.dispatch(new RunAt<Frame>(dialogHandler) {
+			@Override
+			protected void runAt() {
 				log.info("executed");
-				tree.setSelectionPath(treePath);
-				tree.makeVisible(treePath);
-				assert tree.isVisible(treePath);
-			}
-		};
+				jtree.setSelectionPath(treePath);
+				jtree.makeVisible(treePath);
+				assert jtree.isVisible(treePath);
+			}
+		});
 
 	}
@@ -422,34 +393,32 @@
 
 	@Override
+	protected void joinableStart() {
+		super.joinableStart();
+		Dispatching.use(trees, this);
+	}
+
+	@Override
 	protected void joinableInterrupt() {
-		assert isActive();
+		Dispatching.drop(trees, this);
 		super.joinableInterrupt();
-
-		dispatch(new RunAt<Frame>() {
-			@Override
-			public void run() {
-				finish();
-			}
-		});
 	}
 
 	@Override
 	protected void joinableFinish() {
-		assert isActive();
-		log.debug("disposing frame " + this);
-		swing.dispose();
-	}
-
-	// @Override
-	// public boolean isDone() {
-	//	return super.isDone() && !swing.isDisplayable();
-	// }
-
-
-	@Override
-	public String getName() {
-		return title;
-	}
-
+		super.joinableFinish();
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(trees);
+		super.joinableJoin();
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		if (joinable == trees) {
+			proceedToState(state);
+		}
+	}
 
 }
